package datapackage;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import mainpackage.Main;

public class MJClass
{

    private String identifier;
    private Map<String, Variable> variables = new LinkedHashMap();
    private Map<String, Function> functions = new LinkedHashMap();
    private String extendsClass;
    private List<MJClass> extendsList = new ArrayList();    

    public MJClass(String identifier, String extendsClass)
    {
        this.identifier = identifier;
        this.extendsClass = extendsClass;
        
        MJClass tempClass = this; 
        // While there is an extended class added to the list
        while (tempClass.getExtendsClass() != null
               && !tempClass.getExtendsClass().equals(Main.mainClass.getIdentifier()))
        {
            extendsList.add(tempClass);
            tempClass = Main.programClasses.get(tempClass.getExtendsClass());
        }
        extendsList.add(tempClass);        
    }

    public String getIdentifier()
    {
        return identifier;
    }

    public void setIdentifier(String identifier)
    {
        this.identifier = identifier;
    }

    public Map<String, Variable> getVariables()
    {
        return variables;
    }

    public void setVariables(Map<String, Variable> members)
    {
        this.variables = members;
    }

    public Map<String, Function> getFunctions()
    {
        return functions;
    }

    public void setFunctions(Map<String, Function> functions)
    {
        this.functions = functions;
    }

    public String getExtendsClass()
    {
        return extendsClass;
    }

    public void setExtendsClass(String extendsClass)
    {
        this.extendsClass = extendsClass;
    }

    public List<MJClass> getExtendsList()
    {
        return extendsList;
    }

    public void setExtendsList(List<MJClass> extendsList)
    {
        this.extendsList = extendsList;
    }   
    
    public int getVariablePosition(String varId)
    {                                
        // Put all variables of all the classes in the extensList to a List
        List<Variable> varList = new ArrayList();
        for(int i = (extendsList.size() - 1); i >= 0; i--)
        {
            varList.addAll(extendsList.get(i).variables.values());            
        }        
        
        // Browse all variables and return the position of the desired identifier
        // multiplied by 4
        for(int i = (varList.size() - 1); i >= 0 ; i--)
        {            
            if (varList.get(i).getIdentifier().equals(varId))
            {
                return (i + 1) * 4;
            }
        }                   

        return -1;
    }

    public int getFunctionPosition(String funId)
    {                     
        // Built the the list of functions and override when necessary
        List<Function> funList = new ArrayList();
        List<Function> curList = new ArrayList();
        for(int i = (extendsList.size() - 1); i >= 0; i--)
        {
            for(int j = 0; j < extendsList.get(i).functions.size(); j++)
            {
                curList.clear();
                curList.addAll(extendsList.get(i).functions.values());
                for(int c = 0; c < curList.size(); c++)
                {
                    int f;
                    for(f = 0; f < funList.size(); f++)
                    {
                        if(curList.get(c).getIdentifier().equals(funList.get(f).getIdentifier()))
                        {
                            break;
                        }
                    }
                    
                    if(f == funList.size())
                    {
                        funList.add(curList.get(c));
                    }
                }
            }
        }                        

        // Browse all functions and return the position of the desired identifier
        // multiplied by 4        
        for (int i = 0; i < funList.size(); i++)
        {
            if (funList.get(i).getIdentifier().equals(funId))
            {
                return i * 4;
            }
        }

        return -1;
    }
    
    // Returns the position of a function
    public Function getFunctionAt(int index)
    {
        List<Function> funList = new ArrayList();
        funList.addAll(this.getFunctions().values());
        
        return funList.get(index);
    }
}
