package visitor;


import datapackage.MJClass;
import mainpackage.*;
import syntaxtree.*;


public class ClassVisitor extends DepthFirstVisitor
{
    @Override
    public void visit(MainClass n) throws Exception
    {
        Main.mainClass = new MJClass(n.f1.f0.tokenImage, null);
        
        super.visit(n);
    }
    
    @Override
    public void visit(ClassDeclaration n) throws Exception
    {
        //If another class exists with same name
        if(Main.programClasses.containsKey(n.f1.f0.tokenImage) || n.f1.f0.tokenImage.equals(Main.mainClass.getIdentifier()))
        {
            System.err.println("Another class exists with the same name!");
            throw new TypeCheckingError();
        }
        
        Main.programClasses.put(n.f1.f0.tokenImage, new MJClass(n.f1.f0.tokenImage, null));
        
        super.visit(n);
    }
    
    @Override
    public void visit(ClassExtendsDeclaration n) throws Exception
    {
        //If another class exists with the same name or extends a class that doesnt exist
        if(Main.programClasses.containsKey(n.f1.f0.tokenImage) || n.f1.f0.tokenImage.equals(Main.mainClass.getIdentifier()))
        {
            System.err.println("Another class exists with the same name!");
            throw new TypeCheckingError();
        } 
        else if(!Main.programClasses.containsKey(n.f3.f0.tokenImage) && !Main.mainClass.getIdentifier().equals(n.f3.f0.tokenImage))
        {
            System.err.println("Extended class doesn't exists!");
            throw new TypeCheckingError();            
        }
        
        Main.programClasses.put(n.f1.f0.tokenImage, new MJClass(n.f1.f0.tokenImage, n.f3.f0.tokenImage));      
        
        super.visit(n);
    }
}
